#ifndef __CPXDATA_H__
#define __CPXDATA_H__ 1

#ifndef __CDECL
#if defined(__PUREC__) || defined(__TURBOC__) || defined(__AHCC__)
#define __CDECL cdecl
#endif
#ifdef __GNUC__
#define __CDECL
#endif
#endif

#ifndef _WORD
#if defined(__PUREC__) || defined(__TURBOC__) || defined(__AHCC__)
#define _WORD int
#else
#define _WORD short
#endif
#endif
#ifndef _LONG
#define _LONG long
#endif

#ifndef FALSE
#define FALSE 0
#define TRUE  1
#endif


/*  CPX DATA STRUCTURES
 *==========================================================================
 *  XCPB structure is passed TO the CPX
 *  CPXINFO structure pointer is returned FROM the CPX
 *
 *  xcpb structure is initialized in XCONTROL.C
 */

#ifndef __foobar_defined
#define __foobar_defined 1
struct foobar
{
	_WORD dummy;
	_WORD *image;
};
#endif

/* MRETS struct for mouse parameters used by
 * cpx_button, cpx_m1, cpx_m2, cpx_hook
 */
typedef struct
{
	_WORD x;
	_WORD y;
	_WORD buttons;
	_WORD kstate;
} MRETS;

typedef struct
{
	/*   0 */ short handle;
	/*   2 */ short booting;
	/*   4 */ short reserved;
	/*   6 */ short SkipRshFix;

	/*   8 */ void *__CDECL (*Get_Head_Node) (void);	/* ON distribution disk...         */
	/*  12 */ _WORD __CDECL (*Save_Header) (void *ptr);	/* These 2 would be void *reserved */

	/*  16 */ void __CDECL (*rsh_fix) (_WORD num_obs, _WORD num_frstr, _WORD num_frimg,
						  _WORD num_tree, OBJECT *rs_object,
						  TEDINFO *rs_tedinfo, char *rs_strings[],
						  ICONBLK *rs_iconblk, BITBLK *rs_bitblk,
						  long *rs_frstr, long *rs_frimg, long *rs_trindex, struct foobar *rs_imdope);

	/*  20 */ void __CDECL (*rsh_obfix) (OBJECT *tree, _WORD curob);

	/*  24 */ _WORD __CDECL (*Popup) (char *items[], _WORD num_items, _WORD default_item, _WORD font_size, GRECT *button, GRECT *world);

	/*  28 */ void __CDECL (*Sl_size) (OBJECT *tree, _WORD base, _WORD slider, _WORD num_items, _WORD visible, _WORD direction, _WORD min_size);
#define VERTICAL	0
#define HORIZONTAL	1

	/*  32 */ void __CDECL (*Sl_x) (OBJECT *tree, _WORD base, _WORD slider, _WORD value, _WORD num_min, _WORD num_max, void __CDECL (*foo) (void));

	/*  36 */ void __CDECL (*Sl_y) (OBJECT *tree, _WORD base, _WORD slider, _WORD value, _WORD num_min, _WORD num_max, void __CDECL (*foo) (void));

	/*  40 */ void __CDECL (*Sl_arrow) (OBJECT *tree, _WORD base, _WORD slider, _WORD obj,
						   _WORD inc, _WORD min, _WORD max, _WORD *numvar, _WORD direction, void __CDECL (*foo) (void));

	/*  44 */ void __CDECL (*Sl_dragx) (OBJECT *tree, _WORD base, _WORD slider, _WORD min, _WORD max, _WORD *numvar, void __CDECL (*foo) (void));

	/*  48 */ void __CDECL (*Sl_dragy) (OBJECT *tree, _WORD base, _WORD slider, _WORD min, _WORD max, _WORD *numvar, void __CDECL (*foo) (void));

	/*  52 */ _WORD __CDECL (*Xform_do) (OBJECT *tree, _WORD start_field, _WORD puntmsg[]);
	/*  56 */ GRECT *__CDECL (*GetFirstRect) (GRECT *prect);
	/*  60 */ GRECT *__CDECL (*GetNextRect) (void);

	/*  64 */ void __CDECL (*Set_Evnt_Mask) (_WORD mask, MOBLK *m1, MOBLK *m2, long time);
	/*  68 */ _WORD __CDECL (*XGen_Alert) (_WORD id);
#define SAVE_DEFAULTS	0
#define MEM_ERR			1
#define FILE_ERR		2
#define FILE_NOT_FOUND	3

	/*  72 */ _WORD __CDECL (*CPX_Save) (void *ptr, long num);
	/*  76 */ void *__CDECL (*Get_Buffer) (void);

	/*  80 */ _WORD __CDECL (*getcookie) (long cookie, long *p_value);

	/*  84 */ _WORD Country_Code;

	/*  86 */ void __CDECL (*MFsave) (_WORD saveit, MFORM *mf);
#define MFSAVE 1
#define MFRESTORE 0
} XCPB;


#define cpxGet_Head_Node(xcpb) (xcpb)->Get_Head_Node()
#define cpxSave_Header(xcpb,a) (xcpb)->Save_Header(a)
#define cpxGetFirstRect(xcpb,a) (xcpb)->GetFirstRect(a)
#define cpxGetNextRect(xcpb) (xcpb)->GetNextRect()
#define cpxCPX_Save(xcpb,a,b) (xcpb)->CPX_Save(a,b)
#define cpxGet_Buffer(xcpb) (xcpb)->Get_Buffer()
#define cpxgetcookie(xcpb,a,b) (xcpb)->getcookie(a,b)

#if defined(__PUREC__) || defined(__TURBOC__) || defined(__AHCC__) || defined(__MSHORT__)
#define cpxrsh_fix(xcpb,a,b,c,d,e,f,g,h,i,j,k,l,m) (xcpb)->rsh_fix(a,b,c,d,e,f,g,h,i,j,k,l,m)
#define cpxrsh_obfix(xcpb,a,b) (xcpb)->rsh_obfix(a,b)
#define cpxPopup(xcpb,a,b,c,d,e,f) (xcpb)->Popup(a,b,c,d,e,f)
#define cpxSl_size(xcpb,a,b,c,d,e,f,g) (xcpb)->Sl_size(a,b,c,d,e,f,g)
#define cpxSl_x(xcpb,a,b,c,d,e,f,g) (xcpb)->Sl_x(a,b,c,d,e,f,g)
#define cpxSl_y(xcpb,a,b,c,d,e,f,g) (xcpb)->Sl_y(a,b,c,d,e,f,g)
#define cpxSl_arrow(xcpb,a,b,c,d,e,f,g,h,i,j) (xcpb)->Sl_arrow(a,b,c,d,e,f,g,h,i,j)
#define cpxSl_dragx(xcpb,a,b,c,d,e,f,g) (xcpb)->Sl_dragx(a,b,c,d,e,f,g)
#define cpxSl_dragy(xcpb,a,b,c,d,e,f,g) (xcpb)->Sl_dragy(a,b,c,d,e,f,g)
#define cpxXform_do(xcpb,a,b,c) (xcpb)->Xform_do(a,b,c)
#define cpxSet_Evnt_Mask(xcpb,a,b,c,d) (xcpb)->Set_Evnt_Mask(a,b,c,d)
#define cpxXGen_Alert(xcpb,a) (xcpb)->XGen_Alert(a)
#define cpxMFsave(xcpb,a,b) (xcpb)->MFsave(a,b)
#elif defined (__GNUC__)
/* to be done; for now, use -mshort with gcc */
#endif


typedef struct
{
#ifdef COPS_CPX
	_WORD __CDECL (*cpx_call) (GRECT *work, void *_copsdialog);
#else
	_WORD __CDECL (*cpx_call) (GRECT *work);
#endif

	void __CDECL (*cpx_draw) (GRECT *clip);
	void __CDECL (*cpx_wmove) (GRECT *work);

	void __CDECL (*cpx_timer) (_WORD *event);
	void __CDECL (*cpx_key) (_WORD kstate, _WORD key, _WORD *event);
	void __CDECL (*cpx_button) (MRETS *mrets, _WORD nclicks, _WORD *event);
	void __CDECL (*cpx_m1) (MRETS *mrets, _WORD *event);
	void __CDECL (*cpx_m2) (MRETS *mrets, _WORD *event);
	_WORD __CDECL (*cpx_hook) (_WORD event, _WORD *msg, MRETS *mrets, _WORD *key, _WORD *nclicks);

	void __CDECL (*cpx_close) (_WORD flag);
} CPXINFO;


#ifdef __GNUC__
#define asm_name(x) __asm__(x)
#else
#define asm_name(x)
#endif

#ifdef COPS_CPX

#define COPS_MAGIC   0x434f5053L
#define COPS_MIN_VERSION 0x10001L

CPXINFO *__CDECL cpx_init(XCPB *Xcpb, _LONG copsmagic, _LONG copsversion)
#else
CPXINFO *__CDECL cpx_init(XCPB *Xcpb)
#endif
    asm_name("cpx_init");

#endif /* __CPXDATA_H__ */
