/* FONTDEF.H	Font header structure
 * Copyright 1990, Atari Corporation
 * ================================================================
 */

#include "sys/portab.h"


/* fh_flags   */

#define	DEFAULT 1	/* this is the default font (face and size) */
#define	HORZ_OFF  2	/* there are left and right offset tables */
#define STDFORM  4	/* is the font in standard format */
#define MONOSPACE 8	/* is the font monospaced */

/* style bits */

#define	THICKEN	1
#define	LIGHT	2
#define	SKEW	4
#define	UNDER	8
#define	OUTLINE 16
#define	SHADOW	32

typedef struct font_head {
    _WORD font_id;
    _WORD point;
    char name[32];
    _UWORD first_ade;
    _UWORD last_ade;
    _UWORD top;
    _UWORD ascent;
    _UWORD half;
    _UWORD descent;		
    _UWORD bottom;
    _UWORD max_char_width;
    _UWORD max_cell_width;
    _UWORD left_offset;		/* amount character slants left when skewed */
    _UWORD right_offset;		/* amount character slants right */
    _UWORD thicken;		/* number of pixels to smear */
    _UWORD ul_size;		/* size of the underline */
    _UWORD lighten;		/* mask to and with to lighten  */
    _UWORD skew;			/* mask for skewing */
    _UWORD flags;		    

    UBYTE *hor_table;	  	/* horizontal offsets */
    _UWORD *off_table;		/* character offsets  */
    _UWORD *dat_table;		/* character definitions */
    _UWORD form_width;
    _UWORD form_height;

    struct font_head *next_font;/* pointer to next font */
    _UWORD font_seg;
} FONT_HEAD;
