/*
 * TODO
 * prop_get(path, key,..); path=absolu ou relatif  HOME/etc
 * Voir home/test/main.c pour tests
 * 
 */
#include <stddef.h>
#include <osbind.h>
#include <string.h>
#include <ctype.h>
#include "prop_lib.h"

#define PROP_OK         0
#define PROP_ENOTFOUND  1
#define PROP_EACCESS    -1
#define PROP_ENOMEM     -2

#define PROP_USER       0
#define PROP_GLOBAL     1

#ifndef MAX_PATH
#define MAX_PATH 128
#endif

char *prop_buffer = 0;
char prop_path[MAX_PATH];

static void prop_get_name(char *file, short option)
{
    long prop_fh = -1;
    char *home;
    prop_path[0]='\0';
    if (file[0] == '/')
    {
        strcpy(prop_path, file); /* no change */
        return;
    }
    if (option == PROP_USER) /* user */
    {
            if ( (home = getenv("HOME")) != 0 )
                        strcpy(prop_path, home);
            else
                        strcpy(prop_path, "\\home\\");
            strncat(prop_path, ".config/", MAX_PATH-1);
            strncat(prop_path, file, MAX_PATH-1);
            strncat(prop_path, ".inf", MAX_PATH-1);
            prop_fh = Fopen(prop_path, 0);
            if (prop_fh < 0)
            {
                /*prop_copy(file);*/
                prop_fh = Fopen(prop_path, 0); /* retry user file */
            }
    }
    if (prop_fh < 0) /* read system-wide file */
    {
            strcpy(prop_path,"\\etc\\");
            strncat(prop_path, file, MAX_PATH-1);
            strncat(prop_path, ".cnf", MAX_PATH-1);
            prop_fh = Fopen(prop_path, 0);
            if (prop_fh < 0)    /* last try */
            {
                    strcpy(prop_path,"c:\\mint\\1-19-2b8\\");
                    strncat(prop_path, file, MAX_PATH-1);
                    strncat(prop_path, ".cnf", MAX_PATH-1);
                    prop_fh = Fopen(prop_path, 0);
            }
    }
    if (prop_fh < 0)
        strcpy(prop_path, file); /* FIXME reuse default path according to 'option' */
    else
        Fclose(prop_fh);
}

static short prop_open(char *file, short option)
{
        char path[MAX_PATH];
        char *home;
        long prop_fh = -1;
        long prop_size, prop_read;
        
        if (file[0] == '/')
        {
                prop_fh = Fopen(path, 0);
        }
        else
        {
            if (option == PROP_USER) /* user */
            {
                    if ( (home = getenv("HOME")) != 0 )
                        strcpy(path, home);
                    else
                        strcpy(path, "\\home\\");
                    strncat(path, ".config/", MAX_PATH-1);
                    strncat(path, file, MAX_PATH-1);
                    strncat(path, ".inf", MAX_PATH-1);
                    prop_fh = Fopen(path, 0);
                    if (prop_fh < 0)
                    {
                            /*prop_copy(file);*/
                            prop_fh = Fopen(path, 0);
                    }
            }
            if (prop_fh < 0) /* read system-wide file */
            {
                strcpy(path,"\\etc\\");
                strncat(path, file, MAX_PATH-1);
                strncat(path, ".cnf", MAX_PATH-1);
                prop_fh = Fopen(path, 0);
                if (prop_fh < 0)    /* last try */
                {
                    strcpy(path,"c:\\mint\\1-19-2b8\\");
                    strncat(path, file, MAX_PATH-1);
                    strncat(path, ".cnf", MAX_PATH-1);
                    prop_fh = Fopen(path, 0);
                }
            }
        } Cconws("'");Cconws(path);Cconws("'");
        if (prop_fh < 0) 
                return PROP_EACCESS;

        prop_size = Fseek(0, prop_fh, 2); /* offset 0 from end-of-file */
        Fseek(0, prop_fh, 0);
        
        prop_buffer = (char *)Malloc(prop_size+1);
        if (!prop_buffer)    
        {
                Fclose(prop_fh);
                return PROP_ENOMEM;
        }
        prop_read = Fread(prop_fh, prop_size, prop_buffer);
        Fclose(prop_fh);
        if (prop_read != prop_size)
        {
                Mfree(prop_buffer);
                prop_buffer = 0;
                return PROP_EACCESS;
        }
        prop_buffer[prop_size] = '\0';
        return PROP_OK;
}

short prop_close(void)
{
    Mfree(prop_buffer);
    prop_buffer = 0;
    return 0;
}

char *prop_get_line(char *key, short flag)
{
    char *line_ptr = prop_buffer;
    char *saved_ptr;
    
    while(line_ptr[0])  /* for each line */
    {
        saved_ptr = line_ptr;
        while(isspace(*line_ptr)) line_ptr++;   /* skip spaces at beginning */
        if ( (*line_ptr == '#') && (flag == 1) ) line_ptr++;
        if (( strncmp(key, line_ptr, strlen(key)) == 0) && ( (isspace(line_ptr[strlen(key)])) || (line_ptr[strlen(key)]=='=') ) ) /* found */
        {
                return saved_ptr;
        }
        else    /* go to next line */
        {
            while(*line_ptr && *line_ptr != '\n') line_ptr++;
            if (*line_ptr) line_ptr++; /* next char */
        }        
    }  
    return (char*)0L;
}
/* FIXME bug */
void prop_value_from_key(char *ptr_line, char *key, char *gvalue, short glen)
{
    short i;
    char *src = ptr_line;
    while(*src != '=') src++;
    src++;
    while(isspace(*src)) src++;             /* left trim */
    i = 0;
    while(src[i] && src[i] != '\n')
        i++;
    if (i > glen)
        i = glen;
    strncpy(gvalue, src, i);
    gvalue[i]='\0';
    while(isspace(gvalue[i-1])) gvalue[--i]='\0';   /* right trim */
}

short prop_get_value(char *key, char *gvalue, short glen)
{
        char *ptr_line;
        
        ptr_line = prop_get_line(key, 0);
        if (ptr_line)
        {
            prop_value_from_key(ptr_line, key, gvalue, glen);
            return PROP_OK;
        }
        return PROP_ENOTFOUND;
}

short prop_get(char *file, char *key, char *gvalue, short glen, short option)
{
        short err;
        
        err = prop_open(file, option);
        if (err) return err;

        err = prop_get_value(key, gvalue, glen);
        
        if(err == 0) {Cconws("get=");Cconws(gvalue);}
        if(err == 1) {Cconws("get=not found");Cconws(gvalue);}
        
        prop_close();
        
        return err;
}

short prop_put_value(char *key, char *pvalue)
{
    long prop_fh = -1;
    long size2 = 0;
    short i = 0, j = 0;;
    char *ptr_line, *new_line, *next_line = 0;
    
    /* search if line exists, then set next_line */
    ptr_line = prop_get_line(key, 1); /* find both 'key=<val>' and '#key=<val>' */    
    if (ptr_line)
    {
        next_line = ptr_line;
        size2 = 0;
        while(next_line[size2] && next_line[size2] != '\n') size2++;
        next_line = &next_line[size2];
        if (next_line[size2]=='\n')
        {
            next_line = next_line+1;
        }
    }
    
    /* build new line */
    new_line = (char *)Malloc(strlen(key)+6+(pvalue?strlen(pvalue):0)); /* "<key> = '<value>'" */
    if (!new_line) return PROP_ENOMEM;
    /* string to insert */
    i = j = 0;
    if (!pvalue)
    {        
        if (ptr_line)
        {
            if (ptr_line[0] != '#')
            {
                strcpy(new_line,"#");
                i = 1;
            }
            while (ptr_line[j] && ptr_line[j] != '\n') 
            {
                new_line[i]=ptr_line[j];
                i++; j++;
            }
            if (ptr_line[j]=='\n') i++; /* includes '\n' in new_line */
        }
        new_line[i]='\0';
        next_line = &ptr_line[j];
    }
    else
    {
        strcpy(new_line,key);
        strcat(new_line," = ");
        strcat(new_line,pvalue);
        strcat(new_line,"\n");
    }
    
    /* create file */
    prop_fh = Fopen(prop_path, 1); /* TODO */
    if (prop_fh > 0) /* success */
    {
        if ( ptr_line == prop_buffer )  /* 1st line to change (resp. remove) */
        {
            if (strlen(new_line)) Fwrite(prop_fh, strlen(new_line), new_line);
            Fwrite(prop_fh, strlen(next_line), next_line);
        }
        else if (ptr_line) /* update (resp. remove) line */
        {
            Fwrite(prop_fh, ptr_line - prop_buffer, prop_buffer);
            if (strlen(new_line)) Fwrite(prop_fh, strlen(new_line), new_line);
            Fwrite(prop_fh, strlen(next_line), next_line);
        }
        else /* !ptr_line add (resp. do nothing) line */
        {        
            Fwrite(prop_fh, strlen(prop_buffer), prop_buffer);    
            if (strlen(new_line)) Fwrite(prop_fh, strlen(new_line), new_line);
        }
    }
    else
    {
            Mfree(new_line);
            return PROP_EACCESS;
    }    
    Mfree(new_line);
    Fclose(prop_fh);
    return PROP_OK;
}

/*
 * short prop_put(char *file, char *key, char *pvalue, short option)
 */
short prop_put(char *file, char *key, char *pvalue, short option)
{
        short err;
        
        prop_get_name(file, option);
        
        err = prop_open(file, option);
        if (err) return err;
        
        err = prop_put_value(key, pvalue);
        
        prop_close();
        
        return err;
}

/*
 * short prop_del(char *file, char *key, short option);
 */
short prop_del(char *file, char *key, short option)
{
        return prop_put(file, key, (char*)0, option);
}